package eu.dnetlib.uoaadmintools;

import eu.dnetlib.uoaadmintools.configuration.properties.GoogleConfig;
import eu.dnetlib.uoaadmintools.configuration.properties.MailConfig;
import eu.dnetlib.uoaadmintools.configuration.properties.MongoConfig;
import eu.dnetlib.uoaadmintools.configuration.properties.SecurityConfig;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.PropertySource;
import org.springframework.context.annotation.PropertySources;

@SpringBootApplication
@PropertySources({
        @PropertySource("classpath:admintools.properties"),
        @PropertySource(value = "classpath:dnet-override.properties", ignoreResourceNotFound = true)
})
@EnableConfigurationProperties({SecurityConfig.class, MailConfig.class, GoogleConfig.class, MongoConfig.class})
public class UoaAdminToolsApplication {

    public static void main(String[] args) {
        SpringApplication.run(UoaAdminToolsApplication.class, args);
    }
}
