package eu.dnetlib.uoaadmintools.dao;

import eu.dnetlib.uoaadmintools.entities.DivHelpContent;
import org.springframework.data.mongodb.repository.MongoRepository;

import java.util.List;

public interface MongoDBDivHelpContentDAO extends DivHelpContentDAO, MongoRepository<DivHelpContent, String> {
    List<DivHelpContent> findAll();

    List<DivHelpContent> findByCommunity(String community);
    List<DivHelpContent> findByDivId(String divId);
    List<DivHelpContent> findByIsActive(boolean isActive);
    List<DivHelpContent> findByCommunityAndDivId(String community, String divId);
    List<DivHelpContent> findByCommunityAndIsActive(String community, boolean isActive);
    List<DivHelpContent> findByDivIdAndIsActive(String divId, boolean isActive);
    List<DivHelpContent> findByCommunityAndDivIdAndIsActive(String community, String divId, boolean isActive);

    DivHelpContent findById(String Id);

    DivHelpContent save(DivHelpContent divHelpContent);

    void deleteAll();

    void delete(String id);
}
