package eu.dnetlib.uoaadmintools.dao;

import eu.dnetlib.uoaadmintools.entities.DivId;
import org.springframework.data.mongodb.repository.MongoRepository;

import java.util.List;

public interface MongoDBDivIdDAO extends DivIdDAO, MongoRepository<DivId, String> {
    List<DivId> findAll();

    List<DivId> findByPagesContaining(String page);

    DivId findByPagesContainingAndName(String page, String name);
    DivId findByName(String name);

    DivId findById(String Id);

    List<DivId> findByConnect(boolean connect);
    List<DivId> findByCommunities(boolean communities);
    List<DivId> findByOpenaire(boolean openaire);

    DivId save(DivId divId);

    void deleteAll();

    void delete(String id);
}
