package eu.dnetlib.uoaadmintools.dao;

import eu.dnetlib.uoaadmintools.entities.Page;

import org.springframework.data.mongodb.repository.MongoRepository;

import java.util.List;

public interface MongoDBPageDAO extends PageDAO, MongoRepository<Page, String> {
    List<Page> findAll();
    List<Page> findByConnect(boolean connect);
    List<Page> findByCommunities(boolean communities);
    List<Page> findByOpenaire(boolean openaire);

    Page findByConnectAndRoute(boolean connect, String route);
    Page findByCommunitiesAndRoute(boolean communities, String route);
    Page findByOpenaireAndRoute(boolean openaire, String route);

    Page findById(String Id);
    Page findByRoute(String route);

    Page save(Page page);

    void deleteAll();

    void delete(String id);
}
