package eu.dnetlib.uoaadmintools.entities;

import com.fasterxml.jackson.annotation.JsonProperty;

import org.springframework.data.annotation.Id;

import java.util.List;
import java.util.Map;

public class CommunityPage {

    @Id
    @JsonProperty("_id")
    private String id;

    private String route;
    private String name;
    private String type;
    private List<Entity> entities;
    private Boolean isEnabled;
    private Boolean connect;
    private Boolean communities;
    private Boolean openaire;

    // Posiitions where help texts are allowed for this page
    private Boolean top;
    private Boolean bottom;
    private Boolean left;
    private Boolean right;

    public CommunityPage() {}

    public CommunityPage(Page page) {
        this.setId(page.getId());
        this.setRoute(page.getRoute());
        this.setName(page.getName());
        this.setType(page.getType());
        this.setConnect(page.getConnect());
        this.setCommunities(page.getCommunities());
        this.setOpenaire(page.getOpenaire());
        this.setTop(page.getTop());
        this.setBottom(page.getBottom());
        this.setLeft(page.getLeft());
        this.setRight(page.getRight());
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getRoute() {
        return route;
    }

    public void setRoute(String route) {
        this.route = route;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public List<Entity> getEntities() { return entities; }

    public void setEntities(List<Entity> entities) { this.entities = entities; }

    public Boolean getIsEnabled() { return isEnabled; }

    public void setIsEnabled(Boolean isEnabled) { this.isEnabled = isEnabled; }

    public Boolean getConnect() {
        return connect;
    }

    public void setConnect(Boolean connect) { this.connect = connect; }

    public Boolean getCommunities() {
        return communities;
    }

    public void setCommunities(Boolean communities) {
        this.communities = communities;
    }

    public Boolean getOpenaire() {
        return openaire;
    }

    public void setOpenaire(Boolean openaire) {
        this.openaire = openaire;
    }

    public Boolean getTop() {
        return top;
    }

    public void setTop(Boolean top) {
        this.top = top;
    }

    public Boolean getBottom() {
        return bottom;
    }

    public void setBottom(Boolean bottom) {
        this.bottom = bottom;
    }

    public Boolean getLeft() {
        return left;
    }

    public void setLeft(Boolean left) {
        this.left = left;
    }

    public Boolean getRight() {
        return right;
    }

    public void setRight(Boolean right) {
        this.right = right;
    }
}
