package eu.dnetlib.uoaadmintools.entities;

import com.fasterxml.jackson.annotation.JsonProperty;

import org.springframework.data.annotation.Id;

import java.util.List;

public class CommunityResponse {

    @Id
    @JsonProperty("_id")
    private String id;

    private String pid;
    private String name;
    private List<CommunityPage> pages;
    private List<CommunityEntity> entities;
    private Layout layout;

    public CommunityResponse() {}

    public CommunityResponse(Community community) {
        this.setId(community.getId());
        this.setPid(community.getPid());
        this.setName(community.getName());
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getPid() {
        return pid;
    }

    public void setPid(String pid) {
        this.pid = pid;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public List<CommunityPage> getPages() { return pages; }

    public void setPages(List<CommunityPage> pages) { this.pages = pages; }

    public List<CommunityEntity> getEntities() { return entities; }

    public void setEntities(List<CommunityEntity> entities) {
        this.entities = entities;
    }

    public Layout getLayout() {
        return layout;
    }

    public void setLayout(Layout layout) {
        this.layout = layout;
    }
}
