package eu.dnetlib.uoaadmintools.handlers.utils;

import com.google.gson.Gson;
import org.apache.log4j.Logger;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by argirok on 27/2/2018.
 */
public class CommunityInfo {

    List<String> managers = new ArrayList<String>();
    private final Logger log = Logger.getLogger(this.getClass());

    public List<String> getManagers() {
        return managers;
    }

    public void setManagers(List<String> managers) {
        this.managers = managers;
    }

    private CommunityInfo getCommunityInfo(String communityAPI, String community) {
        String url = communityAPI + community;
        URL obj = null;
        String responseStr = null;
        log.debug("Community info url is " + url);

        try {
            obj = new URL(url);
            HttpURLConnection con = (HttpURLConnection) obj.openConnection();
            log.debug("User info response code is: " + con.getResponseCode());
            if (con.getResponseCode() != 200) {
                return null;
            }
            BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
            StringBuffer response = new StringBuffer();
            String inputLine;
            while ((inputLine = in.readLine()) != null) {
                response.append(inputLine).append("\n");
            }
            in.close();
            responseStr = response.toString();
        } catch (Exception e) {
            log.error("An error occured while trying to fetch user info ", e);
            return null;
        }
        return json2CommunityInfo(community);
    }
    private  CommunityInfo json2CommunityInfo(String json){

        log.debug("Try to create CommunityInfo class from json: "+json);
        if (json == null){
            return null;
        }

        BufferedReader br = new BufferedReader(new StringReader(json));
        //convert the json string back to object
        Gson gson = new Gson();
        CommunityInfo communityInfo = null;
        try {
            communityInfo = gson.fromJson(br, CommunityInfo.class);
        }catch(Exception e){
            log.debug("Error in parsing json response. Given json is : "+json, e);
            return null;
        }

        log.debug("Original response.........: "+communityInfo.toString());



        return communityInfo;
    }
}
